# CLMC monitoring specification for a basic scenario

## CONFIGURATION: SLICE
### Compute node configuration

#### Common context
| measurement | tag |
| --- | --- | --- |
| compute_node_config, | slice_id="SLICE1" | 

#### Specific context
| tag | tag | field | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| location='DC1', | comp_node_id='c1' | cpus=4, | memory=8, | storage=16 | 1515583926868000000 |

### Network configuration
__MORE NEEDED FROM IDE__

#### Common context: VLANs
| measurement | tag |
| --- | --- | --- |
| network_resource_config,| slice_id='SLICE1' |

#### Specific context: VLANs
| tag | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| network_id="VNET1" | bandwidth=400 | 1515583926868000000 |

#### Common context: Network interfaces
| measurement | tag |
| --- | --- | --- |
| network_interface_config,| slice_id='SLICE1' |

| tag | tag | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| comp_node_id='c1', | port_id='enps03', | rx_constraint=1000, | tx_constraint=1000 | 1515583926868000000 |



## CONFIGURATION: SF template (TOSCA)
### Media Service SFC states
__MORE NEEDED FROM IDE__


### CONFIGURATION: Media Service SF Instance states
__MORE NEEDED FROM IDE__


### CONFIGURATION: Media Service SF Instance Surrogate states

#### Common context
|measurement|tag|tag|tag|tag|tag|
| --- | --- | --- | --- | --- | --- |
| sf_instance_surrogate_config, | location="DC1", | sfc="Scenario1_Template", | sfc_i="Scenario1_Template_I1", | sf_package="MS_STREAMING", | sf_i="MS_STREAMING_1" | 

#### Specific context
|field|field|field|timestamp|
| --- | --- | --- | --- | --- |
| cpus=2, | memory=4, | storage=8 | 1515583926868000000 |


## Monitor Service Function Instance Surrogate (VMs)
#### Common context: Usage and Performance
All of the specific context measurements below carry the following common context (this has not be replicated for brevity) for both usage and performance measurements. In this example, we illustrate using 2 surrogate VMs.

| measurement | tag | tag | tag | tag | tag |
| --- | --- | --- | --- | --- | --- | --- |
| \<measurement>, | location="DC1", | sfc="Scenario1_Template", | sfc_i="Scenario1_Template_I1", | sf_package="MS_STREAMING", | sf_i="MS_STREAMING_1", | vm_instance ="MPEG_DASH_Server1" |
| \<measurement>, | location="DC2", | sfc="Scenario1_Template", | sfc_i="Scenario1_Template_I1", | sf_package="MS_STREAMING", | sf_i="MS_STREAMING_2", | vm_instance ="MPEG_DASH_Server2" |

Also NOTE: the metrics provided in the measurements below are effectively a 'snapshot' of usage over a relatively small period of time. The length of this snapshot may vary, depending on the underlying implementation of the instrumentation, so we might have to assume this snapshot is close to 'instant'. 

### USAGE: Monitor Service Function Instance Surrogate (VMs)
#### Specific context: CPU usage
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- |
| vm_host_cpu_usage | \<common tags> | cpu_usage=40, | cpu_usage_system=5 | 1515583926868000000 |

##### Specific context: RAM usage
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| vm_host_ram_usage | \<common tags> | ram_usage=1400, | ram_usage_system=512, | 1515583926868000000 |

##### Specific context: storage usage
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- | --- |
| vm_host_storage_usage | \<common tags> | disk_free=8144, | swap_size=1576 | 1515583926868000000 |

##### Specific context: network usage

> Not sure about this one. For example: Bytes over port_M - is this a total byte count that increments over time
> or is it a snapshot shot of throughput on port M over the course of, say, 1 second?

| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| vm_host_network_usage | \<common tags> | rx_bytes_port_M=5242880, | tx_bytes_port_M=15728640 | 1515583926868000000 |


### PERFORMANCE: Monitor Service Function Instance Surrogate (VMs)
Note all metrics described below are assumed to be *averages* over 1 second.

#### Specific context: CPU performance
| measurement | \<common tags> | field | timestamp |
| --- | --- | --- | --- | --- |
| vm_host_cpu_perf | \<common tags> | idle_seconds=0.5 | 1515583926868000000 |

#### Specific context: RAM performance
| measurement | \<common tags> | field | timestamp |
| --- | --- | --- | --- | --- |
| vm_host_ram_perf | \<common tags> | swap_memory_used | 1515583926868000000 |

#### Specific context: storage performance
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- |
| vm_host_storage_perf | \<common tags> | read_bytes=4194304, | write_bytes=2097152 | 1515583926868000000 |

#### Specific context: network performance
| measurement | \<common tags> | field | field | field | field | timestamp |
| --- | --- | --- | --- | --- | --- | --- |
| vm_host_network_perf | \<common tags> | rx_bytes_port_M=4194, | tx_bytes_port_M=2097, | packets_dropped=198, | packets_error=5 | 1515583926868000000 |


### USAGE: Service Function Instance Surrogate Service usage 

#### Common context
| measurement | tag | tag | tag | tag | tag | tag |
| --- | --- | --- | --- | --- | --- | --- |
| \<measurement label> | location="DC1", | sfc="Scenario1_Template", | sfc_i="Scenario1_Template_I1", | sf_package="MS_STREAMING", | sf_i="MS_STREAMING_1", | vm_instance ="MPEG_DASH_Server1" | 

#### Request (WIP)
| measurement | \<common tags> | tag | timestamp |
| --- | --- | --- | --- | --- | --- | --- |
| mpegdash_service_request | \<common tags> | cont_nav='http://netflix.com/scream' | 1515583926868000000 |

#### Response (WIP)



### PERFORMANCE: Service Function Instance Surrogate VM Service performance (KPIs)

